import { FieryData, FieryCacheEntry, FieryTarget, FieryEntry, FieryInstance } from './types';
export declare const callbacks: {
    onInvalidOperation(_data: FieryData, _operation: string): void;
    onUpdate(_data: FieryData, _values: FieryData, _cache: FieryCacheEntry): void;
    onSet(_data: FieryData, _values: FieryData, _cache: FieryCacheEntry): void;
    onDelete(_data: FieryData, _cache: FieryCacheEntry): void;
    onClear(_data: FieryData, _props: string[]): void;
    onGetChanges(_data: FieryData, _cache: FieryCacheEntry, _fields?: string[] | undefined): void;
    onRefresh(_data: FieryData, _cachedOnly?: boolean | undefined): void;
    onBuild(_data: FieryData, _cache: FieryCacheEntry): void;
    onCacheCreate(_cache: FieryCacheEntry): void;
    onCacheDestroy(_cache: FieryCacheEntry): void;
    onSubCreate(_data: FieryData, _sub: string, _cache: FieryCacheEntry): void;
    onSubDestroy(_data: FieryData, _sub: string, _cache: FieryCacheEntry): void;
    onCollectionAdd(_data: FieryData, _target: FieryTarget, _entry: FieryEntry): void;
    onCollectionRemove(_data: FieryData, _target: FieryTarget, _entry: FieryEntry): void;
    onCollectionModify(_data: FieryData, _target: FieryTarget, _entry: FieryEntry): void;
    onCollectionChanged(_target: FieryTarget, _entry: FieryEntry): void;
    onDocumentUpdate(_data: FieryData, _entry: FieryEntry): void;
    onDocumentMissing(_data: FieryData, _entry: FieryEntry): void;
    onInstanceCreate(_instance: FieryInstance): void;
    onInstanceDestroy(_instance: FieryInstance): void;
};
